"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CollectionIndexCache_1 = require("./CollectionIndexCache");
var NodeIterator_1 = require("./NodeIterator");
var ChildNodeList = /** @class */ (function () {
    function ChildNodeList(rootNode) {
        this._rootNode = rootNode;
        this._indexCache = new CollectionIndexCache_1.CollectionIndexCache(this);
    }
    Object.defineProperty(ChildNodeList.prototype, "length", {
        get: function () {
            return this._indexCache.nodeCount;
        },
        enumerable: true,
        configurable: true
    });
    ChildNodeList.prototype.item = function (index) {
        return this._indexCache.nodeAt(index);
    };
    ChildNodeList.prototype.collectionBegin = function () {
        return this._rootNode.firstChild;
    };
    ChildNodeList.prototype.collectionEnd = function () {
        return this._rootNode.lastChild;
    };
    ChildNodeList.prototype.traverseForward = function (node) {
        return node.nextSibling;
    };
    ChildNodeList.prototype.invalidateCache = function () {
        this._indexCache.invalidate();
    };
    ChildNodeList.prototype[Symbol.iterator] = function () {
        return new NodeIterator_1.NodeIterator(this);
    };
    return ChildNodeList;
}());
exports.ChildNodeList = ChildNodeList;
