import { ChildNodeList } from '../ChildNodeList';
import { ElementNode } from './ElementNode';
export declare enum NodeType {
    Element = 1,
    Text = 3,
    Comment = 8,
    Document = 9
}
export declare abstract class AbstractNode {
    nodeName: string;
    nodeType: NodeType | null;
    parentNode: AbstractNode | null;
    firstChild: AbstractNode | null;
    protected _nodeValue: string | null;
    private _childNodes;
    private _nextSibling;
    private _previousSibling;
    constructor();
    get nodeValue(): string | null;
    set nodeValue(value: string | null);
    get parentElement(): ElementNode | null;
    get childNodes(): ChildNodeList;
    get lastChild(): AbstractNode | null;
    get nextSibling(): AbstractNode | null;
    get previousSibling(): AbstractNode | null;
    get nextElementSibling(): ElementNode | null;
    get previousElementSibling(): ElementNode | null;
    appendChild(childNode: AbstractNode): void;
    removeChild(oldChild: AbstractNode): void;
    /**
     * @todo Improve performance when node already has a parent
     * @param newNode
     * @param referenceNode
     */
    insertBefore(newNode: AbstractNode, referenceNode: AbstractNode | null): void;
    private ensurePreInsertionValidity;
}
