import { CollectionIndexCache } from './CollectionIndexCache';
import { NodeIterator } from './NodeIterator';
var ChildNodeList = /** @class */ (function () {
    function ChildNodeList(rootNode) {
        this._rootNode = rootNode;
        this._indexCache = new CollectionIndexCache(this);
    }
    Object.defineProperty(ChildNodeList.prototype, "length", {
        get: function () {
            return this._indexCache.nodeCount;
        },
        enumerable: true,
        configurable: true
    });
    ChildNodeList.prototype.item = function (index) {
        return this._indexCache.nodeAt(index);
    };
    ChildNodeList.prototype.collectionBegin = function () {
        return this._rootNode.firstChild;
    };
    ChildNodeList.prototype.collectionEnd = function () {
        return this._rootNode.lastChild;
    };
    ChildNodeList.prototype.traverseForward = function (node) {
        return node.nextSibling;
    };
    ChildNodeList.prototype.invalidateCache = function () {
        this._indexCache.invalidate();
    };
    ChildNodeList.prototype[Symbol.iterator] = function () {
        return new NodeIterator(this);
    };
    return ChildNodeList;
}());
export { ChildNodeList };
