/// <reference types="titanium" />
import { ProxyFactory, TitaniumElementConstructor, ViewMetadata } from '../elements/TitaniumElement';
export declare type ProxyFactoryResolver<T extends Titanium.Proxy> = () => ProxyFactory<T>;
export interface TitaniumViewElementMeta<T extends Titanium.Proxy> {
    resolveFactory: ProxyFactoryResolver<T>;
    meta: ViewMetadata;
    elementClass?: TitaniumElementConstructor<T>;
}
interface ElementOptions<T extends Titanium.Proxy> extends TitaniumViewElementMeta<T> {
    tagName: string;
}
export declare class TitaniumElementRegistry {
    private static _instance;
    defaultViewMetadata: Partial<ViewMetadata>;
    private elements;
    private constructor();
    static getInstance(): TitaniumElementRegistry;
    registerElement<T extends Titanium.Proxy>(options: ElementOptions<T>): void;
    unregisterElement(tagName: string): void;
    getElement<T extends Titanium.Proxy>(tagName: string): TitaniumViewElementMeta<T>;
    hasElement(tagName: string): boolean;
    getViewFactory<T extends Titanium.Proxy>(tagName: string): ProxyFactory<T>;
    getViewMetadata(tagName: string): ViewMetadata;
    setViewMetadata(tagName: string, meta: ViewMetadata): void;
    private ensureElementIsRegistered;
}
export {};
