import { NavigationWindowElement } from '../elements/NavigationWindowElement';
export function registerCommonTitaniumElements(registry) {
    registry.registerElement({
        tagName: 'ActivityIndicator',
        resolveFactory: function () { return Ti.UI.createActivityIndicator; },
        meta: {
            typeName: 'Ti.UI.ActivityIndicator'
        }
    });
    registry.registerElement({
        tagName: 'AlertDialog',
        resolveFactory: function () { return Ti.UI.createAlertDialog; },
        meta: {
            typeName: 'Ti.UI.AlertDialog',
            detached: true
        }
    });
    registry.registerElement({
        tagName: 'Button',
        resolveFactory: function () { return Ti.UI.createButton; },
        meta: {
            typeName: 'Ti.UI.Button'
        }
    });
    registry.registerElement({
        tagName: 'ImageView',
        resolveFactory: function () { return Ti.UI.createImageView; },
        meta: {
            typeName: 'Ti.UI.ImageView'
        }
    });
    registry.registerElement({
        tagName: 'Label',
        resolveFactory: function () { return Ti.UI.createLabel; },
        meta: {
            typeName: 'Ti.UI.Label'
        }
    });
    registry.registerElement({
        tagName: 'ListView',
        resolveFactory: function () { return Ti.UI.createListView; },
        meta: {
            typeName: 'Ti.UI.ListView',
            detached: true,
            detachChildren: true
        }
    });
    registry.registerElement({
        tagName: 'ListSection',
        resolveFactory: function () { return Ti.UI.createListSection; },
        meta: {
            typeName: 'Ti.UI.ListSection'
        }
    });
    registry.registerElement({
        tagName: 'MaskedImage',
        resolveFactory: function () { return Ti.UI.createMaskedImage; },
        meta: {
            typeName: 'Ti.UI.MaskedImage'
        }
    });
    registry.registerElement({
        tagName: 'NavigationWindow',
        resolveFactory: function () { return Ti.UI.createNavigationWindow; },
        meta: {
            typeName: 'Ti.UI.NavigationWindow',
            detached: true
        },
        elementClass: NavigationWindowElement
    });
    registry.registerElement({
        tagName: 'OptionDialog',
        resolveFactory: function () { return Ti.UI.createOptionDialog; },
        meta: {
            typeName: 'Ti.UI.OptionDialog',
            detached: true
        }
    });
    registry.registerElement({
        tagName: 'Picker',
        resolveFactory: function () { return Ti.UI.createPicker; },
        meta: {
            typeName: 'Ti.UI.Picker',
            detachChildren: true
        }
    });
    registry.registerElement({
        tagName: 'PickerColumn',
        resolveFactory: function () { return Ti.UI.createPickerColumn; },
        meta: {
            typeName: 'Ti.UI.PickerColumn',
        }
    });
    registry.registerElement({
        tagName: 'PickerRow',
        resolveFactory: function () { return Ti.UI.createPickerRow; },
        meta: {
            typeName: 'Ti.UI.PickerRow',
        }
    });
    registry.registerElement({
        tagName: 'ProgressBar',
        resolveFactory: function () { return Ti.UI.createProgressBar; },
        meta: {
            typeName: 'Ti.UI.ProgressBar',
        }
    });
    registry.registerElement({
        tagName: 'RefreshControl',
        resolveFactory: function () { return Ti.UI.createRefreshControl; },
        meta: {
            typeName: 'Ti.UI.RefreshControl',
            detached: true
        }
    });
    registry.registerElement({
        tagName: 'ScrollableView',
        resolveFactory: function () { return Ti.UI.createScrollableView; },
        meta: {
            typeName: 'Ti.UI.ScrollableView',
            detachChildren: true
        }
    });
    registry.registerElement({
        tagName: 'ScrollView',
        resolveFactory: function () { return Ti.UI.createScrollView; },
        meta: {
            typeName: 'Ti.UI.ScrollView',
        }
    });
    registry.registerElement({
        tagName: 'SearchBar',
        resolveFactory: function () { return Ti.UI.createSearchBar; },
        meta: {
            typeName: 'Ti.UI.SearchBar',
            detached: true
        }
    });
    registry.registerElement({
        tagName: 'Slider',
        resolveFactory: function () { return Ti.UI.createSlider; },
        meta: {
            typeName: 'Ti.UI.Slider',
        }
    });
    registry.registerElement({
        tagName: 'Switch',
        resolveFactory: function () { return Ti.UI.createSlider; },
        meta: {
            typeName: 'Ti.UI.Switch',
        }
    });
    registry.registerElement({
        tagName: 'Tab',
        resolveFactory: function () { return Ti.UI.createTab; },
        meta: {
            typeName: 'Ti.UI.Tab',
            detached: true
        }
    });
    registry.registerElement({
        tagName: 'TableView',
        resolveFactory: function () { return Ti.UI.createTableView; },
        meta: {
            typeName: 'Ti.UI.TableView',
            detached: true,
            detachChildren: true
        }
    });
    registry.registerElement({
        tagName: 'TableViewRow',
        resolveFactory: function () { return Ti.UI.createTableViewRow; },
        meta: {
            typeName: 'Ti.UI.TableViewRow',
        }
    });
    registry.registerElement({
        tagName: 'TableViewSection',
        resolveFactory: function () { return Ti.UI.createTableViewSection; },
        meta: {
            typeName: 'Ti.UI.TableViewSection',
        }
    });
    registry.registerElement({
        tagName: 'TabbedBar',
        resolveFactory: function () { return Ti.UI.createTabbedBar; },
        meta: {
            typeName: 'Ti.UI.TabbedBar',
        }
    });
    registry.registerElement({
        tagName: 'TabGroup',
        resolveFactory: function () { return Ti.UI.createTabGroup; },
        meta: {
            typeName: 'Ti.UI.TabGroup',
            detached: true
        }
    });
    registry.registerElement({
        tagName: 'TextArea',
        resolveFactory: function () { return Ti.UI.createTextArea; },
        meta: {
            typeName: 'Ti.UI.TextArea',
        }
    });
    registry.registerElement({
        tagName: 'TextField',
        resolveFactory: function () { return Ti.UI.createTextField; },
        meta: {
            typeName: 'Ti.UI.TextField',
        }
    });
    registry.registerElement({
        tagName: 'Toolbar',
        resolveFactory: function () { return Ti.UI.createToolbar; },
        meta: {
            typeName: 'Ti.UI.Toolbar',
            detachChildren: true
        }
    });
    registry.registerElement({
        tagName: 'View',
        resolveFactory: function () { return Ti.UI.createView; },
        meta: {
            typeName: 'Ti.UI.View',
        }
    });
    registry.registerElement({
        tagName: 'WebView',
        resolveFactory: function () { return Ti.UI.createWebView; },
        meta: {
            typeName: 'Ti.UI.WebView',
        }
    });
    registry.registerElement({
        tagName: 'Window',
        resolveFactory: function () { return Ti.UI.createWindow; },
        meta: {
            typeName: 'Ti.UI.Window',
            detached: true
        }
    });
}
